﻿using System.Collections.Generic;

namespace Whitebrim.BetterSteeringWheel
{
    public static class SteeringWheelExtension
    {
        private static Dictionary<uint, bool> isLocked = new Dictionary<uint, bool>();
        public static Dictionary<RGD_SteeringWheel, bool> RGD_isLocked = new Dictionary<RGD_SteeringWheel, bool>();

        public static bool IsLocked(this SteeringWheel steeringWheel)
        {
            if (!isLocked.ContainsKey(steeringWheel.ObjectIndex))
            {
                isLocked.Add(steeringWheel.ObjectIndex, false);
            }
            return isLocked[steeringWheel.ObjectIndex];
        }

        public static void Lock(this SteeringWheel steeringWheel, bool value)
        {
            if (!isLocked.ContainsKey(steeringWheel.ObjectIndex))
            {
                isLocked.Add(steeringWheel.ObjectIndex, value);
                return;
            }
            isLocked[steeringWheel.ObjectIndex] = value;
        }

        public static void AddLockRGD(this RGD_SteeringWheel RGD_SteeringWheel, SteeringWheel steeringWheel)
        {
            RGD_SteeringWheel.AddLockRGD(steeringWheel.IsLocked());
        }

        public static void AddLockRGD(this RGD_SteeringWheel RGD_SteeringWheel, bool value)
        {
            RGD_isLocked.Add(RGD_SteeringWheel, value);
        }
    }
}
